import CorgeeStorageHelper from './globals/CorgeeStorageHelper';
import Moment from 'moment';

export function isSafari(){
    var isSafari = navigator.appVersion.search('Safari') != -1 && navigator.appVersion.search('Chrome') == -1 && navigator.appVersion.search('CrMo') == -1 && navigator.appVersion.search('CriOS') == -1;
    return isSafari;
}

export function dropDownFixPosition(button, dropdown, showRight, pixelsLeft) {        
    var dropDownTop = (button.offset().top + button.outerHeight()) - $('body.core2').scrollTop();

    var posLeft = 0;
    if (pixelsLeft) {
        posLeft = button.offset().left - pixelsLeft;
    } else {
        posLeft = button.offset().left;
    }

    dropdown.addClass('positionFixed');
    if (showRight) {
        dropDownTop = button.offset().top - $('body.core2').scrollTop();
        posLeft += button.outerWidth();
    }
    dropdown.css('top', dropDownTop + "px");
    dropdown.css('left', posLeft + "px");
}

export function setDropdownMenuPosition(button) {
    let dropdownMenuPosition = getDropdownMenuPosition(button);

    if(dropdownMenuPosition && dropdownMenuPosition.dropdown && dropdownMenuPosition.dropdown.length>0){
        dropdownMenuPosition.dropdown.css({
            'top': dropdownMenuPosition.top,
            'left': dropdownMenuPosition.left
        });
    }
}

export function getDropdownMenuPosition(button) {
    let actionMenuContainer = button.closest('.cw-action-menu.dropdown').first();

    //Maybe in some time can be that dropdown-menu will not exists, for the render, but in this case works
    let dropdown = actionMenuContainer.find('.dropdown-menu').first();

    let newTopPosition = 0, newLeftPosition = 0;

    var item = button, //$(element),
    windowH = window.innerHeight,
    windowW = window.innerWidth;
        
    var dropdownW = dropdown.outerWidth();
    var data = button.get(0).getBoundingClientRect();
    //console.log(data, item);
    if (data.top <= windowH / 2) {
        newTopPosition = item.offset().top - window.scrollY;        
    } else {
        newTopPosition = item.offset().top - dropdown.outerHeight() - window.scrollY        
    };

    if (item.offset().left > (windowW - dropdownW)) {
        newLeftPosition = item.offset().left - dropdownW;        
    } else {
        newLeftPosition = item.offset().left;        
    }

    return {
        top: newTopPosition,
        left: newLeftPosition,
        dropdown: dropdown
    };    
}

export function showSeeMoreContent(body, createdBy){
    let showSeeMoreContent = false;
    if (body !== undefined && body !== null) { // && body !== '') {
        if ((body.indexOf('<div class="detail-update-embed') !== 0 || createdBy !== 'admin')) {
            showSeeMoreContent = true;
        }
    }
    return showSeeMoreContent;
}

export function getBodyValidated(item, isReply = false){
    let htmlBody = "<p><br></p>";
    let bodyRemplace = '<div>' + item.Body + '</div>';        
    if ($(bodyRemplace).length > 0) {
        if ($(bodyRemplace).text().trim().length == 0 && $(bodyRemplace).find('img') == 0) {
            bodyRemplace = "";
        }
    } else {
        bodyRemplace = item.Body ? item.Body.trim() : item.Body;
    }

    if (($(bodyRemplace).length > 0 
        && ($(bodyRemplace).text() != "" || $(bodyRemplace).find('img').length > 0 || $(bodyRemplace).is('img')) 
        || $(bodyRemplace).length == 0 && bodyRemplace.length > 0) || item.Attachments && item.Attachments.length > 0 || item.ConfigValueId == 15) {
            htmlBody = item.Body;
    } else {
        let canEditAction = false;
        if(isReply===true){
            canEditAction = replyHasEditPermissions(item);
        } else {
            canEditAction = convHasEditPermissions(item);
        }

        if (canEditAction) {
            htmlBody = '<div class="update-body-hover"><p title="Double click to update"></p></div>';
        } else {
            htmlBody = '<div><p></p></div>';
        }
    }
    return htmlBody;
}

export function convHasEditPermissions(conversation, reply){
    let canEditAction = false;
    if(conversation){
        if (CorgeeStorageHelper.canEdit() && (conversation.CreatedByID === CorgeeStorageHelper.personId() || conversation.ConfigValueId === 9)) {
            canEditAction = true;
        }
        if (CorgeeStorageHelper.isAdmin()) {
            canEditAction = true;
        }
        if (conversation.ConfigValueId === 15 || conversation.IsEnable===false) {
            canEditAction = false;
        }
    } else if (reply) {
        if (CorgeeStorageHelper.canEdit() && reply.CreatedById === CorgeeStorageHelper.personId()) {
            canEditAction = true;
        }
        if (CorgeeStorageHelper.isAdmin()) {
            canEditAction = true;
        }
    }
    
    return canEditAction;
}

export function convHasDeletePermissions(conversation){
    let canDeleteAction = false;
    if(conversation && conversation.ConfigValueId !== 15){
        if (CorgeeStorageHelper.canDelete() && conversation.CreatedByID === CorgeeStorageHelper.personId()) {
            canDeleteAction = true;
        }
        if (CorgeeStorageHelper.isAdmin()) {
            canDeleteAction = true;
        }        
    }
    return canDeleteAction;
}

export function replyHasEditPermissions(reply){

    let canEditAction = false;
    if(reply){
        if (CorgeeStorageHelper.canEdit() && (reply.CreatedByID === CorgeeStorageHelper.personId() || reply.CreatedById === CorgeeStorageHelper.personId())) {
            canEditAction = true;
        }
        if (CorgeeStorageHelper.isAdmin()) {
            canEditAction = true;
        }
        if (reply.IsEnable===false) {
            canEditAction = false;
        }
    }
    return canEditAction;
}

export function replyHasDeletePermissions(reply){
    let canDeleteAction = false;
    if(reply){
        if (CorgeeStorageHelper.canDelete() && (reply.CreatedByID === CorgeeStorageHelper.personId() || reply.CreatedById === CorgeeStorageHelper.personId())) {
            canDeleteAction = true;
        }
        if (CorgeeStorageHelper.isAdmin()) {
            canDeleteAction = true;
        }
        if (reply.IsEnable===false) {
            canDeleteAction = false;
        }
    }
    return canDeleteAction;
}

export function getMomentDateTime(dateTimeValue){
    let momentDateStr = "";
    if(dateTimeValue){
        momentDateStr = Moment(dateTimeValue).fromNow();
    }
    return momentDateStr;
}

export function applyFormatDate(dateTimeValue, formatDate){
    let momentDateStr = "";
    if(dateTimeValue){
        momentDateStr = Moment(dateTimeValue).format(formatDate);
    }
    return momentDateStr.toString();
}


export function getImageExtensions(){
    return [".jpg", ".jpe", ".bmp", ".gif", ".png", ".jpeg"];
}

export function extInImageExtensions(extension){    
    var a = getImageExtensions().indexOf(extension);
    if(a>=0){
        return true;
    } else {
        return false;
    }
}

export function getDocumentClassName(docType) {
    switch (docType) {
        case '.pdf':
            return 'file Pdf';
        case '.doc':
            return 'file Doc';
        case '.docx':
            return 'file Doc';
        case '.xls':
            return 'file Xls';
        case '.xlsx':
            return 'file Xls';
        case '.zip':
            return 'file Zip';
        case '.rar':
            return 'file Zip';
        case '.ppt':
            return 'file Ppt';
        case '.pptx':
            return 'file Ppt';
        default:
            return 'file Def';
    }
}

export function inArray(arr, itemValue) {
    if(arr){
        var result = arr.findIndex(function (itemArr){
            return itemArr === itemValue;
        });
        if (result!=-1){
            return true;
        } else {
            return false;
        }
    } else {
        return false;
    }    
}