import * as APIUtils from './Utils';

/**
 * Services for manage calls to endpoints for 
 */

 class customFieldsService {
    static save(requestConfig) {        
        return APIUtils.callFetch(requestConfig.api, 'api/customfieldvalue/', 'PUT', requestConfig.request, true);        
    }

    static savePost(requestConfig) {        
        return APIUtils.callFetch(requestConfig.api, 'api/customfieldvalue/', 'POST', requestConfig.request);        
    }

    static getCustomFieldsByItemId(requestConfig) {        
        return APIUtils.callFetch(requestConfig.api, 'api/CustomField/GetCustomFieldsByItemId?CoreTaskId=' + requestConfig.coreTaskId + '&IsDeleted=' + requestConfig.isDeleted + '&ProjectId=' + requestConfig.projectId);        
    }

    static getEmptyCustomFieldsByConfigValueId(requestConfig) { 
        let params = "?";
        if (requestConfig.configValueId ) {
            params += "configValueId=" + requestConfig.configValueId ;
        }
        if (requestConfig.projectId) {
            params += "&ProjectId=" + requestConfig.projectId;
        }       
        return APIUtils.callFetch(requestConfig.api, 'api/configvalue/GetEmptyCustomFieldsByConfigValueId' + params);
    }

    static getListComboBox(requestConfig) {        
        return APIUtils.callFetch(requestConfig.api, requestConfig.serviceUrl);
    }

    static getImageResult(requestConfig) {        
        return APIUtils.callFetch(requestConfig.api, 'api/customfieldvalue/GetImageResult?customImageId=' + requestConfig.request);
    }

    static getThumbnail(requestConfig) {        
        return APIUtils.callFetch(requestConfig.api, 'api/customfieldvalue/GetThumbnail?customValue=' + requestConfig.request);
    }

    static uploadImage(requestConfig) {        
        return APIUtils.callFetch(requestConfig.api, 'api/uploadimage/', 'POST', requestConfig.request);        
    }

    static getPersonCustomFieldsByItemId(requestConfig) {        
        return APIUtils.callFetch(requestConfig.api, 'api/CustomField/GetPersonCustomFieldsByItemId?PersonId=' + requestConfig.personId + '&IsDeleted=' + requestConfig.isDeleted);        
    }
    
    static getProjectCustomFieldsByItemId(requestConfig) {        
        return APIUtils.callFetch(requestConfig.api, 'api/CustomField/GetProjectCustomFieldsByItemId?ProjectId=' + requestConfig.projectId 
        + '&IsDeleted=' + requestConfig.isDeleted + '&IsProject=true&GetGroupsOneCall=false');        
    }

    static getLayersByConfigValueId(requestConfig) {        
        return APIUtils.callFetch(requestConfig.api, 'api/layer/GetLayersByConfigValueId?ProjectId=' + requestConfig.projectId + '&ConfigValueId=' + requestConfig.configValueId);        
    }
}

export default customFieldsService;
