import React from 'react';
import CustomFieldsService from '../api/CustomFieldsService';
// import * as CorgeeHelper from '../DashboardSearchResult/CorgeeHelper';
import * as CorgeeHelper from '../CorgeeHelper';
import $ from 'jquery';
import moment from 'moment';
//import DatePicker from 'react-bootstrap-date-picker'; // Does not work with React 16
import DatePicker from 'react-16-bootstrap-date-picker'; // Estable React 16


import './InputDateField.css';
import ClickOutSide from '../globals/ClickOutSide';

class InputDateField extends React.Component {

    constructor(props) {
        super(props);
        this.state = {
            value: props.customField.Value === undefined || props.customField.Value === null || props.customField.Value == '' || props.customField.Value == 'Not Set' ? '' : moment(props.customField.Value).format(),
            EditorEnabled: props.EditorEnabled,
            editableValue: '',
            disableAutoSave: props.disableAutoSave,
            customField: props.customField,
            canEdit: props.canEdit && props.customField.ConversationIsEnable,
            apiConfig: props.apiConfig,
            idPicket: props.customField.CustomFieldValueId == undefined ? props.customField.CustomFieldId : props.customField.CustomFieldValueId
        }

        this.handleChange = this.handleChange.bind(this);
        this.save = this.save.bind(this);
        this.enableEditor = this.enableEditor.bind(this);
        this.disableEditor = this.disableEditor.bind(this);
        this.handleOnShow = this.handleOnShow.bind(this);
        this.handleOnClose = this.handleOnClose.bind(this);
        this.onUpdateCustomField = this.onUpdateCustomField.bind(this);
        this.applyStyle = this.applyStyle.bind(this);
        this.onCustomFieldUpdated = this.onCustomFieldUpdated.bind(this);
    }

    componentWillReceiveProps(nextProps) {
        let momentDate = (nextProps.customField.Value === undefined || nextProps.customField.Value === null || nextProps.customField.Value == '' || nextProps.customField.Value == 'Not Set') ? '' : moment(nextProps.customField.Value).format()
        this.setState({ customField: nextProps.customField, value: momentDate });
    }

    handleChange(event) {

        if (event !== null) {
            this.setState({ value: event });
        } else {
            this.setState({ value: '' });
        }

        setTimeout(() => {
            this.handleOnClose();
            this.save();
            event != null ? this.disableEditor() : null;
        });
    }

    onCustomFieldUpdated(param) {
        if (this.props.onCustomFieldUpdated && typeof (this.props.onCustomFieldUpdated) === 'function') {
            this.props.onCustomFieldUpdated(param);
        }
    }

    save() {
        const { value, editableValue, disableAutoSave } = this.state;

        var copyCustomField = Object.assign({}, this.state.customField);

        // We make sure that the new value is different to the previous one
        if (value !== editableValue && value != null) {

            // Assign the new values
            copyCustomField.Value = null;
            if (value !== '') {
                copyCustomField.Value = moment(value).format('MM/DD/YYYY');
            }

            this.setState({ editableValue: value });

            //Do not save if autoSaved is disabled
            if (disableAutoSave == 'false' || disableAutoSave === undefined || !disableAutoSave) {

                let requestSave = {
                    api: this.props.apiConfig,
                    request: copyCustomField
                };

                if (copyCustomField.CustomFieldValueId === undefined || copyCustomField.CustomFieldValueId === null || copyCustomField.CustomFieldValueId === 0) {
                    CustomFieldsService.savePost(requestSave).then(data => {
                        copyCustomField.CustomFieldValueId = data.CustomFieldValueId;

                        try {
                            this.setState({ customField: copyCustomField });

                            setTimeout(() => {
                                this.onUpdateCustomField();
                                this.onCustomFieldUpdated(copyCustomField);
                            });
                        }
                        catch (err) {
                            console.log(err);
                        }
                    });

                } else {
                    CustomFieldsService.save(requestSave).then(data => {

                        try {
                            this.setState({ customField: copyCustomField });

                            setTimeout(() => {
                                this.onUpdateCustomField();
                                this.onCustomFieldUpdated(copyCustomField);
                            });
                        }
                        catch (err) {
                            console.log(err);
                        }
                    });
                }
            }
            else {
                // Disable the control
                this.disableEditor();

                this.setState({ customField: copyCustomField });
                setTimeout(() => {
                    this.onUpdateCustomField();
                });
            }
        } else {
            // Disable the control
            this.disableEditor();
        }
    }

    handleOnShow(event) {
        $('body').find('.note-popover').attr('style', 'display:none');
        $('body').css('overflow', 'hidden');

        var element = $(this.refs.inputDateRef);

        var initialScroll = element.closest('.layer-details-container').scrollTop();
        element.closest('.layer-details-container').on('scroll', e => {
            var newScroll = element.closest('.layer-details-container').scrollTop();
            if (initialScroll != newScroll) {
                this.disableEditor();
            }
        });

        var initialScroll2 = element.closest('.sortableDashboard').scrollTop();
        element.closest('.sortableDashboard').on('scroll', e => {
            var newScroll2 = element.closest('.sortableDashboard').scrollTop();
            if (initialScroll2 != newScroll2) {
                this.disableEditor();
            }
        });

        var initialScroll3 = element.closest('md-dialog-content').scrollTop();
        element.closest('.md-dialog-content').on('scroll', e => {
            var newScroll3 = element.closest('md-dialog-content').scrollTop();
            if (initialScroll3 != newScroll3) {
                this.disableEditor();
            }
        });

        var initialScroll4 = element.closest('.card-body-area').scrollTop();
        element.closest('.card-body-area').on('scroll', e => {
            var newScroll4 = element.closest('.card-body-area').scrollTop();
            if (initialScroll4 != newScroll4) {
                this.disableEditor();
            }
        });

        element.closest('.layer-custom-fields-container').on('scroll', e => {
            this.disableEditor();
        });

        setTimeout(() => {
            this.applyStyle();
        });
    }

    handleOnClose() {
        $('body').find('.note-popover').attr('style', 'display:none');
        $('body').removeAttr('style');

        var element = $(this.refs.inputDateRef);

        element.closest('.layer-details-container').off('scroll');
        element.closest('.card-body-area').off('scroll');
        element.closest('md-dialog-content').off('scroll');
        element.closest('.add-inline-task').off('scroll');
    }

    enableEditor() {
        const { canEdit, customField, value } = this.state;

        if (canEdit && customField.ConversationIsEnable) {
            this.setState({ EditorEnabled: true, editableValue: value });

            $('body').find('.note-popover').attr('style', 'display:none');
            $('body').attr('style', 'overflow: hidden !important');

        }
    }

    disableEditor() {
        this.setState({ EditorEnabled: false });
        $('body').attr('style', '');
    }

    applyStyle() {
        var windowModal = $('.conversation-editor');
        var control = $(this.refs.inputDateRef).find('#datepicker_group').find('.form-control');
        var cal = $('[id*="date-picker-popover"]');
        var top = 0, left = 0;

        let isProjectView = (window.location.href.indexOf('ProjectDetails') > -1) ? true : false;

        if (windowModal.offset() && windowModal.length > 0 && windowModal.find('[id*="date-picker-popover"]').length > 0) {
            left = control.offset().left - windowModal.offset().left;
            top = (control.offset().top + 35) - windowModal.offset().top;
            var style = { position: 'fixed', top: top + 'px', left: left + 'px' };
            cal.css(style);
        }
        else {
            if (control.length > 0) {

                left = control.offset().left;
                top = control.offset().top + 35 - $('html').scrollTop();

                if (CorgeeHelper.isSafari()) {
                    top = top - $('body').scrollTop();
                }

                var style = { position: 'fixed', top: top + 'px', left: left + 'px' };
                cal.css(style);
            }
        }
    }

    onUpdateCustomField() {
        if (this.props.UpdateCustomFields) {
            this.props.UpdateCustomFields(this.state.customField);
        }
    }

    render() {
        const { EditorEnabled, canEdit, value, customField, idPicket } = this.state;
        return (
            <div ref='inputDateRef' id='inputDateRef' className='corgee_com_custom-fields-field-A _DEL_field-A custom-field-id' >
                <span className='corgee_com_custom-fields-title _DEL_title'>{customField.Name}</span>

                <div className='click-to-edit'>

                    {!EditorEnabled ?
                        <div onClick={this.enableEditor} className={canEdit ? 'lbl-editable-input' : 'lbl-non-editable-input'} id={'input' + idPicket}>
                            {value != '' ? moment(this.state.value).format('MM/DD/YYYY') : 'Not Set'}
                        </div> : null
                    }

                    {EditorEnabled ?
                        <div className="corgee_com_custom-fields-date" onFocus={this.handleOnShow}>
                            {/* <div className='_DEL_input-append _DEL_date' onFocus={this.handleOnShow}> */}
                                <ClickOutSide onClickOutSide={this.disableEditor}>
                                    <DatePicker id='datepicker'
                                        placeholder=''
                                        value={this.state.value}
                                        onChange={this.handleChange}
                                        onBlur={this.disableEditor}
                                        style={{ width: '120px' }}
                                        dateFormat={'MM/DD/YYYY'}
                                        showClearButton={false}
                                        autoFocus={true} />
                                </ClickOutSide>
                            {/* </div> */}
                        </div> : null
                    }
                </div>

            </div>
        )

    }
}

export default InputDateField;