import React from 'react';
import PropTypes from 'prop-types';

import Select from 'react-select';
import 'react-select/dist/react-select.css';

import * as APIUtils from '../api/Utils';
import $ from 'jquery';
import CustomFieldsService from '../api/CustomFieldsService';
import * as domUtil from './DOMHelper';

// import { RenderToBody } from "../globals/AppendToBody";
import RenderInBody from "../globals/RenderInBody";
import shortid from 'shortid';

import './MultiSelectField.css';
import ClickOutSide from '../globals/ClickOutSide';
import * as CorgeeHelper from '../CorgeeHelper';

class MultiSelectField extends React.Component{ 
	constructor(props, context){	 
        super(props, context);	
        
        let stringValueArr = [];
        if(props.customField.Value!==undefined && props.customField.Value!==null && props.customField.Value!==""){
            stringValueArr = props.customField.Value.split(","); 

            stringValueArr = stringValueArr.map(function(item){ return parseInt(item) });
        }        

        this.state = {
            canEdit: (props.canEdit && props.customField.ConversationIsEnable),
            customField: props.customField,
            selectedValues: stringValueArr,
            selectedText: props.customField.SelectedValuesText,                        
            items: [],            
            editorEnabled: false,            
            api:{
                    url: this.props.apiConfig.url,
                    token: this.props.apiConfig.token
                },
            listMenuStyle: {
                left: '0px',
                top: '0px',
                position: 'fixed',
                width: '150px'
            },
            elementId: shortid.generate(),
            isProjectView: (window.location.href.indexOf("ProjectDetails") > -1) ? true : false,
            isFromInfoWindow: false,
            targetTop: 0,
            targetTopFactor: 0,
            isFromTabDetails: false,
            isConversationDetailsView: (window.location.href.indexOf("ConversationDetails") > -1) ? true : false,

            listPosition: {
                left: 0,
                top: 0
            }
        }

        this.enableEditor = this.enableEditor.bind(this);
        this.save = this.save.bind(this);
        this.onBlur = this.onBlur.bind(this);
        
        this.getDataBy = this.getDataBy.bind(this);
        this.getSelectedGroupsByIds = this.getSelectedGroupsByIds.bind(this);
        this.onSelectValuesChange = this.onSelectValuesChange.bind(this);
        this.onUpdateCustomField = this.onUpdateCustomField.bind(this);
        //this.applyStyle = this.applyStyle.bind(this);
        //this.onApplyStyle2 = this.onApplyStyle2.bind(this);
        this.onApplyStyle = this.onApplyStyle.bind(this);
        this.onCloseSelect = this.onCloseSelect.bind(this);
    }  
    componentDidMount() {
        if (this.refs.corgeeMultiSelect) {
            let containerElement = $(this.refs.corgeeMultiSelect);
            if (containerElement.closest(".details-tab-directive").length > 0) {
                this.setState({ isFromInfoWindow: true });
            }   
            if(containerElement.closest('#canvasDetails').length>0){
                this.setState({ isFromTabDetails: true });
            }
        }
    }

    onApplyStyle() {        
        if (!this.state.isFromInfoWindow && !this.state.isFromTabDetails){
            let isProjectView = (window.location.href.indexOf("ProjectDetails") > -1) ? true : false;
            this.setState({ isProjectView: isProjectView} );

            let containerElement = $(this.refs.corgeeMultiSelect);            

            let targetElement = containerElement.find("#select-target-" + this.state.elementId);            
            let targetTopValue = targetElement.offset().top;                        

            if(window.scrollY>0){
                targetTopValue -= window.scrollY;
            }

            let selectElement = $("#select-render-" + this.state.elementId);            
            selectElement.find('.Select').first().attr("style", "position:fixed; top: " + targetTopValue + "px; left: " + targetElement.offset().left + "px");

            containerElement.closest(".layer-custom-fields-container").first().on("scroll", this.onCloseSelect);
        }
    }

    onCloseSelect() {
        this.setState({ editorEnabled: false });

        //let containerElement = $(this.refs.corgeeMultiSelect);
        //containerElement.closest(".layer-custom-fields-container").first().off("scroll wheel DOMMouseScroll mousewheel", this.onCloseSelect);
    }
    
    componentWillReceiveProps(nextProps){
        let stringValueArr = [];
        if(nextProps.customField.Value!==undefined && nextProps.customField.Value!==null && nextProps.customField.Value!==""){
            stringValueArr = nextProps.customField.Value.split(","); 
            stringValueArr = stringValueArr.map(function(item){ return parseInt(item) });
        }        

        this.setState({customField:nextProps.customField, selectedText:nextProps.customField.SelectedValuesText, selectedValues:stringValueArr });
    }
   
    onSelectValuesChange(itemsSelected){
        const {customField} = this.state;

        let selectedValuesCopy = itemsSelected.map(function(item){ return item[customField.ValueField]});
        let selectedTextCopy = itemsSelected.map(function(item){ return item[customField.TextField]});                   

        let selectedTextString = '';
        if(selectedValuesCopy.length===0){
            selectedTextString = "Not Set";
        } else {
            selectedTextString = selectedTextCopy.join(', ');
        }
        this.setState({ selectedValues: selectedValuesCopy, selectedText: selectedTextString });                  
    }

    save(){
        const {customField, selectedValues, selectedText} = this.state;

        let lastValuesString = undefined;
        if(customField.Value!==undefined && customField.Value!==null && customField.Value!==""){
            lastValuesString = customField.Value !== selectedValues.join(',') ? customField.Value : undefined;
        }

        let selectedValuesString = selectedValues.join(',');         
        //stringValueArr = stringValueArr.map(function(item){ return parseInt(item) });

        var copyCustomField = Object.assign({}, this.state.customField);
        copyCustomField.Value = selectedValuesString;
        copyCustomField.PreviousValue = lastValuesString;
        copyCustomField.SelectedValuesText = selectedText;

        let requestSave = {
            api: this.state.api,
            request: copyCustomField
        };

        if (customField.CustomFieldValueId == 0) {
            CustomFieldsService.savePost(requestSave).then(function(data){
                copyCustomField.CustomFieldValueId = data.CustomFieldValueId;
                                                        
                this.setState({customField: copyCustomField});

                setTimeout(function(){
                    this.onUpdateCustomField();
                }.bind(this));
                //customFieldValueService.updateCFV(copyCustomField, 1,1, element);
            }.bind(this));

        } else {            
            CustomFieldsService.save(requestSave).then(function(data){                    
                this.setState({customField: copyCustomField});

                setTimeout(function(){
                    this.onUpdateCustomField();
                }.bind(this));
                //customFieldValueService.updateCFV(copyCustomField, 1,1, element);
            }.bind(this));            
        }
        this.setState({editorEnabled: false});
    }

    onBlur(){
        const {disableAutoSave} = this.props;

        let element = $(this.refs.corgeeMultiSelect);
        element.closest(".layer-details-container").css('overflow', '');
        $('body').css('overflow', '');

        var infoWindowScrollContainer = element.closest('.details-tab-directive .card-body-area')
        if (infoWindowScrollContainer.length > 0) {
            infoWindowScrollContainer.css('overflow', '');
        }

        element.closest(".layer-details-container").unbind("scroll");
        element.closest(".card-body-area").unbind("scroll");
        element.closest("md-dialog-content").unbind("scroll");
        //element.closest(".sortableDashboard").unbind("scroll");
        element.closest(".add-inline-task").unbind("scroll");
        //element.closest('.layer-custom-fields-container').unbind('scroll');

        const {customField, selectedValues, selectedText} = this.state;

        let continueSave = true;
        if((customField.Value===null || customField.Value==="") && selectedValues.length===0){
            continueSave = false;
        }
        if(continueSave){
            if (disableAutoSave == "false" || disableAutoSave === undefined || !disableAutoSave) {
                this.save();
            } else {                        
                let lastValuesString = undefined;
                if(customField.Value!==undefined && customField.Value!==null){
                    lastValuesString = customField.Value !== selectedValues.join(',') ? customField.Value : undefined;
                }
        
                let selectedValuesString = selectedValues.join(',');         
                //stringValueArr = stringValueArr.map(function(item){ return parseInt(item) });
        
                var copyCustomField = Object.assign({}, this.state.customField);
                copyCustomField.Value = selectedValuesString;
                copyCustomField.PreviousValue = lastValuesString;
                copyCustomField.SelectedValuesText = selectedText;

                this.setState({customField: copyCustomField});

                setTimeout(function(){
                    this.onUpdateCustomField();
                }.bind(this));
            }
        }
        
        this.onCloseSelect();
    }
    
    //function loadData(serviceUrl, customField, configValueId, projectId, securityGroupIds, groups, isFromMultiselect, conversationIds) {
    getDataBy(){        
        let result;

        const {customField, isFromMultiselect, conversationIds, configValueId, projectId, securityGroupIds, apiConfig, groups} = this.props;
        if(customField){     
            var groupIds = '';
            
            if (groups != undefined) {
                groupIds = this.getSelectedGroupsByIds(groups);
            }

            let serviceUrl = customField.ServiceUrl;
            if(serviceUrl.indexOf("?")===-1){
                serviceUrl += "?";
            } else {
                serviceUrl += "&";
            }
            
            if (isFromMultiselect && customField.ValueField == 'PersonID'){   
                result = APIUtils.callFetch(this.state.api, 
                    serviceUrl + 'conversationIds=' + conversationIds + '&layerId=' + customField.LayerId);

            } else {
                result = APIUtils.callFetch(this.state.api, 
                    serviceUrl + 'configValueId=' + configValueId 
                    + '&layerId=' + customField.LayerId 
                    + '&projectId=' + projectId 
                    + ((securityGroupIds) ? '&securitygroups=' + securityGroupIds : '')
                    + ((groupIds) ? '&groups=' + groupIds : '')
                ); 

                //$http.get(serviceUrl, { params: { configValueId: configValueId, layerId: customField.LayerId, projectId: projectId, securitygroups: securityGroupIds, groups: groupIds } }       
            }
        } 
        return result;       
    }

    getSelectedGroupsByIds(selectedGroupsIds) {
        var groups = [];
        for (var i = 0; i < selectedGroupsIds.length; i++) {
            groups.push(selectedGroupsIds[i].GroupId);
        };
        return groups && groups.length > 0 ? groups.join(',') : "";;
    };

    enableEditor(e){        
        const {canEdit, isConversationDetailsView} = this.state;

        this.setState({editorEnabled: !this.state.editorEnabled});

        if(canEdit){
            setTimeout(function(){
                this.getDataBy().then(function(response) {
                    let data = response;
                    this.setState({items: data});
                    
                    if (this.refs.selectComboMulti) {
                        this.refs.selectComboMulti.focus();
                    }
                }.bind(this));
            }.bind(this));

            if(!isConversationDetailsView && !CorgeeHelper.isSafari()){
                $('body').css('overflow', 'hidden');
            }
            
            let element = $(this.refs.corgeeMultiSelect);
            let window = $(".conversation-editor");

            if(window.length > 0){
                element.closest(".layer-details-container").css('overflow', 'hidden');
            }
            
            var infoWindowScrollContainer = element.closest('.details-tab-directive .card-body-area');
            if (infoWindowScrollContainer.length > 0) {
                infoWindowScrollContainer.css('overflow', '');
            }        
    
            var initialScroll2 = element.closest(".sortableDashboard").scrollTop();
            element.closest(".sortableDashboard").on('scroll', function (e) {
                var newScroll2 = element.closest(".sortableDashboard").scrollTop();
                if (initialScroll2 != newScroll2) {
                    this.onBlur();
                }
            }.bind(this));
    
            var initialScroll3 = element.closest("md-dialog-content").scrollTop();
            element.closest("md-dialog-content").on('scroll', function (e) {
                var newScroll3 = element.closest("md-dialog-content").scrollTop();
                if (initialScroll3 != newScroll3) {
                    this.onBlur();
                }
            }.bind(this));
    
            setTimeout(function(){
                var initialScroll4 = element.closest(".card-body-area").scrollTop();
                element.closest(".card-body-area").on('scroll', function (e) {
                    var newScroll4 = element.closest(".card-body-area").scrollTop();
                    if (initialScroll4 != newScroll4) {
                        this.onBlur();
                    }
                }.bind(this));
            }.bind(this));
            
            var initialScroll5 = element.closest(".add-inline-task").scrollTop();
            element.closest(".add-inline-task").on('scroll', function (e) {
                var newScroll5 = element.closest(".add-inline-task").scrollTop();
                if (initialScroll5 != newScroll5) {
                    this.onBlur();
                }
            }.bind(this));
    
            element.closest('.layer-custom-fields-container').on('scroll', function (e) {
                this.onBlur();
            }.bind(this));        
    
            //Check if this is necesary
            /*if (canEdit) {
                this.setState({EditorEnabled:true, editableValue:selectedValue.value});
            }*/

            let elementPosition = e.currentTarget.getBoundingClientRect();
            this.setState({
                listPosition: {
                    left: elementPosition.x,
                    top: elementPosition.y
                }
            });
        }
    }   

    onUpdateCustomField(){
        if(this.props.UpdateCustomFields){
            this.props.UpdateCustomFields(this.state.customField);
        }
    }    
    
    render(){
        const { customField, canEdit, items, editorEnabled, selectedValues, selectedText, listMenuStyle, isFromInfoWindow, isFromTabDetails, isConversationDetailsView, listPosition} = this.state;        

        let isProjectView = (window.location.href.indexOf("ProjectDetails") > -1) ? true : false;

        let styleRender = { position: 'fixed', zIndex: 100, top: listPosition.top, left: listPosition.left };
        // let styleRender = { position: 'fixed', zIndex: 100, top: 0 };
        // if (isProjectView) {
        //     styleRender.top = 15;
        // }

        let containerSelectorId = "select-target-" + this.state.elementId;
        let container = $(this.refs.selectComboMulti);
        let isModalEditor = $(this.refs.corgeeMultiSelect).closest('.conversation-editor').length > 0 ? true : false;
        let containerSelectorTarget = "#subtree-container";
        
        if (isFromInfoWindow || isFromTabDetails || (isConversationDetailsView && !isModalEditor)){
            containerSelectorTarget = "#" + containerSelectorId;
            styleRender.fontSize = 15;    
            styleRender.position = "absolute";
        }        

        return(
        <div ref="corgeeMultiSelect" className="corgee_com_custom-fields-field-A _DEL_field-A">
            <span className="corgee_com_custom-fields-title _DEL_title">{customField.Name}</span>            
            <div className="click-to-edit">                    
                {!editorEnabled ? 
                    <div onClick={this.enableEditor} className={canEdit? 'lbl-editable-input' : 'lbl-non-editable-input'}>
                        {selectedText || "Not Set"}
                    </div> : null}
                {editorEnabled ?
                        <div id={containerSelectorId} style={{ margin: 0, padding: 0 }} >
                            {/* <RenderToBody subtreeContainer={containerSelectorTarget}>                             */}
                            <RenderInBody>
                                <div id={"select-render-" + this.state.elementId} className="corgee_com_custom-fields-combobox-multiselect _DEL_comboBoxRef _DEL_multiselect-hidden-control-container" style={styleRender} >
                            <ClickOutSide onClickOutSide={this.onBlur} >
                            <Select ref="selectComboMulti"
                                autoFocus={true}                            
                                options={items}                            
                                onChange={this.onSelectValuesChange }
                                onOpen={this.onApplyStyle}
                                value={selectedValues}
                                onBlur={this.onBlur}
                                multi={true}
                                searchable={true}
                                openOnFocus={true}
                                autosize={false}
                                closeOnSelect={false}
                                labelKey={customField.TextField}
                                valueKey={customField.ValueField}
                                style={{width: '150px'}}
                            />
                            </ClickOutSide>
                            </div> 
                            </ RenderInBody>
                        {/* </RenderToBody>    */}
                    </div>                 
                    : null}
            </div>
        </div>
        );
    }
}


MultiSelectField.propTypes = { 	
    //config receive api values
    config: PropTypes.object, //Localstorage
    canEdit: PropTypes.bool, //Lo vamos a obtener del localstorage, igual token y el api url

    //Props for this CustomField    
    customField: PropTypes.object.isRequired,
    saveCallback: PropTypes.func, //????
    disableAutoSave: PropTypes.bool,
    configValueId: PropTypes.number,
    projectId: PropTypes.number,    
    groups: PropTypes.array,
    isFromMultiselect: PropTypes.bool,
    conversationIds:PropTypes.string
};

export default MultiSelectField;