import React from 'react';
import PropTypes from 'prop-types';
import { findDOMNode } from 'react-dom';
import $ from 'jquery';
import ReactSummernote from 'react-summernote';
import 'react-summernote/dist/react-summernote.css';
import 'react-summernote/lang/summernote-ru-RU';


// Import bootstrap(v3 or v4) dependencies
import 'bootstrap/js/modal';
import 'bootstrap/js/dropdown';
import 'bootstrap/js/tooltip';

//import {connect} from 'react-redux';
//import {bindActionCreators} from 'redux';
//import * as personActions from '../../actions/personActions';

//import HashtagApi from '../../api/HashtagApi';
//import {configApp} from '../../constants/appConstants';
//let Localstorage_PersonId = sessionStorage.getItem(configApp.appPrefix + '_personid');

//import PureRenderMixin from 'react-addons-pure-render-mixin';

/*
 * Component for use summernote
 */
class Summernote extends React.Component{
    constructor(props, context){
        super(props, context);
                
        let dataPeopleName = [];
        let dataListPeople = [];                
        let dataListGroup = [];            

        /*for (var i = 0; i < props.listPeople.length; i++) {   
            if(props.listPeople[i]!==Localstorage_PersonId){
                dataListPeople.push(props.listPeople[i]);
            }
        }
        dataPeopleName = dataListPeople.map((people)=> (people.Name));
                    
        if(props.listGroup.length > 0){
            for (var i = 0; i < props.listGroup.length; i++) {
                dataPeopleName.push(props.listGroup[i].NameGroup) - 1;
                var groupData = {};
                groupData.NameGroup = props.listGroup[i].NameGroup;
                groupData.ParticipantsByID = props.listGroup[i].ParticipantsByID;
                groupData.ParticipantsByName = props.listGroup[i].ParticipantsByName;
                dataListGroup.push(groupData);
            }            
        }*/
    
        this.state = {
            Body: props.body,
            listPeople: dataListPeople,
            listPeopleName: dataPeopleName,
            hashtags: [],
            listGroupName: dataListGroup
        }

        this.addCheckList = this.addCheckList.bind(this);
        this.onChangeSummernoteInternal = this.onChangeSummernoteInternal.bind(this); 
        this.onInit = this.onInit.bind(this);        

        //this.shouldComponentUpdate = PureRenderMixin.shouldComponentUpdate.bind(this);       
    }
    
    componentDidMount(){        
        //Is not required on Store Redux, only on this component
        /*HashtagApi.getHashtags().then(responseHashtags =>{
            this.setState({hashtags: responseHashtags});
        }).catch(error =>{
            console.log("Summernote (getHashtags)", error);            
        });
        */
    }    
    onChangeSummernoteInternal(content) {        
        this.setState({Body: content});        
        this.props.onChangeBody(content);        
    }    
    addCheckList(context) {
        var ui = $.summernote.ui,
            cbIdAux = 0;

        var button = ui.button({
            contents: '<i class="fa fa-check-square-o"/>',
            tooltip: 'Insert a Checklist',
            click: function () {
                context.invoke('editor.pasteHTML', '<span contentEditable="false"><input id="id_' + cbIdAux + '" type="checkbox" class="note-editor-checkbox"/></span>&nbsp;');                    
                setTimeout(function () {
                    var checkbox = $('.note-editor').find('.note-editor-checkbox#id_' + cbIdAux);

                    $(checkbox).bind('change', function () {
                        var checked = $(this).attr('checked') ? false : true;
                        $(this).attr('checked', checked);
                    });
                    cbIdAux++;
                }, 300);
            }
        });

        return button.render();
    }
    onInit(params){
        if(params){
            let element = $(params.editable);
            var checkboxesFromList = element.find('.note-editor').find('.note-editor-checkbox');

            $.each(checkboxesFromList, function (index, input) {
                $(input).attr('disabled', false);
                $(input).on('change', function () {
                    var checked = $(this).attr('checked') ? false : true;
                    $(this).attr('checked', checked);
                });
            });
        }
    }

    render() {
                
        const {listPeople, listPeopleName, listGroupName, Body} = this.state;                        

        const listItems = (        
            <ReactSummernote 
                value={Body}
                options={{                
                    height: 150,
                    focus: true,  
                    dialogsInBody: true,  
                    disableDragAndDrop: true,  
                    shortcuts: false,
                    hint: {
                        mentions: listPeopleName,
                        match: /\B@(\w*)$/,
                        search: function (keyword, callback) {
                            keyword = keyword.toLowerCase();                            
                            callback($.grep(this.mentions, function (item) {                                
                                return item.toLowerCase().indexOf(keyword) != -1;
                            }));
                        },
                        template: function (item) {
                            return item;
                        },
                        content: function (item, node) {
                            var personId = 0;
                            var hashtagId = 0;
                            if (this.match.toString() == /\B@(\w*)$/) {
                                var isGroup = false;
                                var groupId;
                                var participantsId = [];
                                var participantsName = [];

                                for (var i = 0; i < listGroupName.length; i++) {
                                    if (listGroupName[i].NameGroup == item) {
                                        isGroup = true;
                                        participantsId = listGroupName[i].ParticipantsByID.split(',');
                                        participantsName = listGroupName[i].ParticipantsByName.split(',');
                                    }
                                }

                                if (isGroup == true) {
                                    var spanParent = {};
                                    spanParent = document.createElement('span');
                                    for (var i = 0; i < participantsId.length; i++) {
                                        var blueSpan = {};
                                        blueSpan = document.createElement('span');
                                        $(blueSpan).append(participantsName[i]).css('color', '#62AACB').attr('person-id', participantsId[i]);
                                        var nextSpan = {};
                                        nextSpan = document.createElement('span');
                                        $(nextSpan).append($(blueSpan));
                                        $(nextSpan).append('&nbsp;');
                                        $(nextSpan).append('&nbsp;');
                                        $(spanParent).append($(nextSpan));
                                    }

                                    return spanParent;

                                } else {

                                    for (var i = 0; i < listPeople.length; i++) {
                                        if (listPeople[i].Name == item) {
                                            personId = listPeople[i].PersonID;
                                        }
                                    }
                                    var blueSpan = document.createElement('span');
                                    $(blueSpan).append(item).css('color', '#62AACB').attr('person-id', personId);
                                    var nextSpan = document.createElement('span');
                                    $(nextSpan).append($(blueSpan));
                                    $(nextSpan).append('&nbsp;');
                                    $(nextSpan).append('&nbsp;');
                                    return nextSpan;
                                }
                            } else {
                                var blueSpan = document.createElement('span');
                                $(blueSpan).append(item).css('color', '#62AACB').attr('hashtag-id', hashtagId);
                                var nextSpan = document.createElement('span');
                                $(nextSpan).append($(blueSpan));
                                $(nextSpan).append('&nbsp;');
                                $(nextSpan).append('&nbsp;');
                                return nextSpan;
                            }                                                      
                        }    
                    },
                    toolbar: summernoteToolbar,
                    buttons: {
                        AddCheckList: this.addCheckList
                    },
                    callbacks: {
                            onInit: function () {
                                var checkboxesFromList = $('.note-editor').find('.note-editor-checkbox');
                                $.each(checkboxesFromList, function (index, input) {
                                    $(input).attr('disabled', false);
                                    $(input).on('change', function () {
                                        var checked = $(this).attr('checked') ? false : true;
                                        $(this).attr('checked', checked);
                                    });
                                });

                            }                            
                    },                    
                }}
            onChange={this.onChangeSummernoteInternal}
            onInit={this.onInit}
        />
        );

        return(
                <div>{listItems}</div>
        )
    }
}

Summernote.propTypes = {  
    /*
    * Initial value Body (Html)
    */
    body: PropTypes.string,  
    /*
     * Callback for changes in summernote
     */
    onChangeBody: PropTypes.func,   
    /*
     * Data list people of redux store for tags
     */
    listPeople: PropTypes.array,
    /*
     * Data list groups chat of redux store for tags
     */
    listGroup: PropTypes.array
};

function mapStateToProps(state, ownProps){    
    return {        
        listPeople: state.persons,
        listGroup: state.groupsList
    };
}

function mapDispatchToProps(dispatch){
    return {
        actions: bindActionCreators(personActions, dispatch)       
    };
}

export default Summernote;

const summernoteToolbar = [
            ['style', ['bold', 'italic', 'underline']],
            ['fontface', ['fontname']],
            ['textsize', ['fontsize']],
            ['fontclr', ['color']],
            ['alignment', ['ul', 'ol', 'paragraph', 'lineheight']],
            ['insert', ['link', 'picture']],
            ['customOptions', ['AddCheckList']]
];