
import CorgeeStorageHelper from './CorgeeStorageHelper';

export function getVisibleLayers(layers) {
    let layersValidated = [];
    let layersToHide = CorgeeStorageHelper.getLayersToHide();
    
    if (layers){
        for (let index = 0; index < layers.length; index++) {
            const element = layers[index];
            if (layersToHide){
                let hideLayer = layersToHide.findIndex((item) => { return item.LayerId === element.LayerId });
                if (hideLayer===-1){
                    layersValidated.push(element);
                }
            } else {
                layersValidated.push(element);
            }      
        }
    }

    return layersValidated;
}

export function getLayersName(layers) {
    let layersNameArray = [], layersNameString = "";

    for (let i = 0; i < layers.length; i++) {
        if (layers[i].Name) {
            layersNameArray.push(layers[i].Name);
        } else {
            layersNameArray.push(layers[i].LayerName);
        }
    };

    if (layersNameArray.length == 0) {
        layersNameString = "Not Set"
    } else {
        layersNameString = layersNameArray.join(', ');
    };

    return layersNameString;
}

export function getGroupsNames(conversationGroups) {
    var groupsNames = [];
    for (var i = 0; i < conversationGroups.length; i++) {
        if (conversationGroups[i].Name) {
            groupsNames.push(conversationGroups[i].Name);
        } else if (conversationGroups[i].GroupName) {
            groupsNames.push(conversationGroups[i].GroupName);
        }

    };

    return groupsNames && groupsNames.length > 0 ? groupsNames.join(', ') : "Not Set";
};
