class CorgeeStorageHelper{    
    static appPrefix(){
        return "ls.C2";
    }

    static givenName(){        
        return localStorage.getItem(this.appPrefix() + '_givenname');            
    }

    static conv_maxAllowedUpload(){        
        return localStorage.getItem(this.appPrefix() + '_conv_maxAllowedUpload');            
    }

    static personId(){
        return parseInt(localStorage.getItem(this.appPrefix() + "_personid"));
    }

    static getApiConfig(propsApiConfig){ 
        if(propsApiConfig===undefined) {
            propsApiConfig = {};
        }
        
        propsApiConfig.apiUrl = this.apiURL(propsApiConfig);
        propsApiConfig.authToken = this.getToken(propsApiConfig);
        propsApiConfig.apiHeader = this.apiHeader(propsApiConfig);
        propsApiConfig.canEdit = this.canEdit(propsApiConfig);
        propsApiConfig.canDelete = this.canDelete(propsApiConfig);
        
        return propsApiConfig;
    }

    static apiURL(propsApiConfig){        
        let valueReturn = "";
        try {
            valueReturn =  ((propsApiConfig!==undefined && propsApiConfig.apiUrl!==undefined && propsApiConfig.apiUrl!==null) 
            ? propsApiConfig.apiUrl : localStorage.getItem(this.appPrefix() + '_apiURL')).toString();            
        } catch (e) { 
            //console.log('configServices:apiURL', e);            
        }
        return valueReturn;
    }

    static apiHeader(propsApiConfig){
        return {
            'Accept': 'application/json',
            'Content-Type': 'application/json;charset=UTF-8',
            Authorization: 'Bearer ' + ((propsApiConfig!==undefined && propsApiConfig.authToken!==undefined && propsApiConfig.authToken!==null) 
            ? propsApiConfig.authToken : this.getToken())
        }
    }

    static getToken(propsApiConfig){        
        return (propsApiConfig!==undefined && propsApiConfig.authToken!==undefined && propsApiConfig.authToken!==null) 
        ? propsApiConfig.authToken : localStorage.getItem(this.appPrefix() + '_access_token');
    }

    static isAuthenticated(propsApiConfig){
        let result = false;
        let token = localStorage.getItem(this.appPrefix() + '_access_token');
        if (token !== '' && token !== null && token !== undefined) {
            result = true;
        }

        if(!result && propsApiConfig!==undefined){            
            if (propsApiConfig.authToken !== '' && propsApiConfig.authToken !== null && propsApiConfig.authToken !== undefined) {
                result = true;
            }            
        }

        return result;
    }
    
    static isAdmin(propsApiConfig){              
        try {
            if(propsApiConfig!==undefined && propsApiConfig.isAdmin!==undefined && propsApiConfig.isAdmin!==null){ 
                return propsApiConfig.isAdmin;
            } else {
                let data = JSON.parse(sessionStorage.getItem('C2_data'));
                return (data.isAdmin.toString().toLowerCase()==="true") ? true : false;
            }
        } catch (e) {            
            return false;
        }
    }
    
    static isAdminProject(){         
        try {
            let data = JSON.parse(sessionStorage.getItem('C2_data'));
            return (data.isAdminProject.toString().toLowerCase()==="true") ? true : false;
        } catch (e) {            
            return false;
        }
    }
    
    static canEdit(propsApiConfig){         
        try{
            if(propsApiConfig!==undefined && propsApiConfig.canEdit!==undefined && propsApiConfig.canEdit!==null){ 
                return propsApiConfig.canEdit;
            } else {
                let data = JSON.parse(sessionStorage.getItem('C2_data'));               

                return (data.canEdit.toString().toLowerCase()==="true") ? true : false;            
            }
        } catch(e) {            
            return false;
        }        
    }

    static canDelete(propsApiConfig){         
        try{
            if(propsApiConfig!==undefined && propsApiConfig.canDelete!==undefined && propsApiConfig.canDelete!==null){ 
                return propsApiConfig.canDelete;
            } else {
                let data = JSON.parse(sessionStorage.getItem('C2_data'));
                return (data.canDelete.toString().toLowerCase()==="true") ? true : false;
            }
        } catch(e) {            
            return false;
        }
    }

    static layerId(){        
      return localStorage.getItem(this.appPrefix() + "_layerid");
    }

    static getLayersToHide(){         
        try{            
            return JSON.parse(sessionStorage.getItem('C2_LayersToHide'));                           
        } catch(e) {            
            return false;
        }        
    }

    static enableHelpTooltips(){        
        let isEnabled = localStorage.getItem(config.appPrefix + '_enableHelpTooltips') === "true" ? true : false;
        return isEnabled;
    }

    static getAllLayers() {
        try {
            let layers = JSON.parse(sessionStorage.getItem('C2_AllLayers'));
            return (layers !== null) ? layers : [];
        } catch (e) {
            return [];
        }
    }

    static isUserExternal() {
        try {
            var data = JSON.parse(sessionStorage.getItem(config.appPrefix + '_data'));
            return $.parseJSON(data.External.toString().toLowerCase());
        } catch (e) {
            return false;
        }
    }

    static getProjectNameConfig() {
        let projectName = sessionStorage.getItem('C2_ProjectNameconfig');
        if (projectName === null || projectName === undefined || projectName === ""){
            projectName = "Project";
        } else {
            let nameShow = projectName;
            if (projectName.endsWith("s")) {
                nameShow = projectName.substring(0, (projectName.length - 1));
            }
            projectName = nameShow;
        }
        return projectName;
    }
}

export default CorgeeStorageHelper;